<?php
/*
	 Atomic Photo Album
	 Copyright (C) 2001,2002 Constantin Charissis <charchi@ifrance.com>

	 This program is free software; you can redistribute it and/or
	 modify it under the terms of the GNU General Public License
	 as published by the Free Software Foundation; either version 2
	 of the License, or (at your option) any later version.

	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.

	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

mysql_connect($apa_dbhost,$apa_dblogin,$apa_dbpass) or die ("unable to connect to database");
@mysql_select_db($apa_db) or die ("unable to select database");

$apa_tables['config'] = $apa_table_prefix."config";
$apa_tables['users'] = $apa_table_prefix."users";
$apa_tables['albums'] = $apa_table_prefix."albums";
$apa_tables['photos'] = $apa_table_prefix."photos";
$apa_tables['comments'] = $apa_table_prefix."comments";
$apa_tables['viewsbuffer'] = $apa_table_prefix."viewsbuffer";
$apa_tables['commentsbuffer'] = $apa_table_prefix."commentsbuffer";
$apa_tables['searchindex'] = $apa_table_prefix."searchindex";

function apa_mysql_query($query,$file,$line)
{
  global $apa_query_counter;
  global $apa_error;
  $apa_error = 0;

  $type = substr($query,0,6);

  $result = mysql_query($query);
  if(!$result)
  {
    $apa_error = 1;
    print("<strong>MySQL Error (Query type : $type, File : $file, Line : $line) : ".mysql_error()."</strong><br>\n");
  }
  else
    $apa_query_counter++;
  
  return $result;
}

// Creating option table
if(!$apa_upgrading)
{
  $apa_query = "SELECT * ".
               "FROM $apa_tables[config]";
  $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
  if(mysql_num_rows($result))
  {
    while($apa_row = mysql_fetch_array($result))
      $apa_options[$apa_row[option_name]] = $apa_row[option_value];
  }
  else
    die("Can't read config table !\n");
  // Setting default language
  include($apa_module_basedir."lang/lang.$apa_options[lang].inc.php");
}

// Fetching file extension
$apa_fp = fopen($apa_module_basedir."apa_ext.inc.php","r");
if($apa_fp)
{
  $apa_ext = trim(fgets($apa_fp,10));
  fclose($apa_fp);
}
else
  $apa_ext = "php";

// PHP >= 4.1.0 Compatibility

if (!empty($_GET)) {
  extract($_GET);
} else if (!empty($HTTP_GET_VARS)) {
  extract($HTTP_GET_VARS);
}

if (!empty($_POST)) {
  extract($_POST);
} else if (!empty($HTTP_POST_VARS)) {
  extract($HTTP_POST_VARS);
}

if (!empty($_COOKIE))
  extract($_COOKIE);

if (!empty($_SERVER))
  extract($_SERVER);

/*
   This function take all HTTP_GET_VARS
   and return an urlencoded get string
 */
function apa_parse_get_vars()
{
  $get_vars = "";
  
  if(isset($HTTP_GET_VARS))
  {
    while(list($key,$val) = each($HTTP_GET_VARS))
    {
      $key = urlencode(stripslashes($key));
      $val = urlencode(stripslashes($val));

      $get_vars .= "$key=$val&";
    }
  }
  elseif(isset($_GET))
  {
    while(list($key,$val) = each($_GET))
    {
      $key = urlencode(stripslashes($key));
      $val = urlencode(stripslashes($val));

      $get_vars .= "$key=$val&";
    }
  }

  return $get_vars;
}

/* 
   This function take all HTTP_POST_VARS
   and return an urlencoded get string
 */
function apa_parse_post_vars()
{
  $post_vars = "";

  if(isset($HTTP_POST_VARS))
  {
    while(list($key,$val) = each($HTTP_POST_VARS))
    {
      $key = urlencode(stripslashes($key));
      $val = urlencode(stripslashes($val));

      $post_vars .= "$key=$val&";
    }
  }
  elseif(isset($_POST))
  {
    while(list($key,$val) = each($_POST))
    {
      $key = urlencode(stripslashes($key));
      $val = urlencode(stripslashes($val));

      $post_vars .= "$key=$val&";
    }
  }

  return $post_vars;
}

/*
  This function return an urlencoded get string
  of both GET and POST variables
*/
function apa_parse_form_vars()
{
  return apa_parse_get_vars().apa_parse_post_vars();
}

/*
  This function print GET variables into
  hidden form variables
*/
function apa_print_hidden_get_vars()
{
  if(isset($HTTP_GET_VARS))
  {
    while(list($key,$val) = each($HTTP_GET_VARS))
      apa_print_hidden($key,$val);
  }
  elseif(isset($_GET))
  {
    while(list($key,$val) = each($_GET))
      apa_print_hidden($key,$val);
  }
}

/*
  This function print POST variables into
  hidden form variables
*/
function apa_print_hidden_post_vars()
{
  if(isset($HTTP_POST_VARS))
  {
    while(list($key,$val) = each($HTTP_POST_VARS))
      apa_print_hidden($key,$val);
  }
  elseif(isset($_POST))
  {
    while(list($key,$val) = each($_POST))
      apa_print_hidden($key,$val);
  }
}

/*
  This function prints both POST and GET
  variables into hidden form variables
*/
function apa_print_hidden_form_vars()
{
  apa_print_hidden_post_vars();
  apa_print_hidden_get_vars();
}

function apa_print_hidden($name,$value)
{
  print("<input type=\"hidden\" name=\"$name\" value=\"$value\">\n");
}

function apa_print_link($page,$vars,$txt_link,$target_blank)
{
  global $apa_ext,$apa_include_page;
  global $apa_options;
  global $apa_module_pn;
  global $apa_module_pn_url;

  if( !($apa_options[as_module] || $apa_module_pn))
    print("<a href=\"$page.$apa_ext?$vars\"");
  else
  {
    if(!$apa_module_pn)
    {
      $vars.="&apa_target=".$page;
      print("<a href=\"".$apa_include_page."?".apa_parse_form_vars().$vars."\"");
    }
    else
    {
      print("<a href=\"".$apa_module_pn_url."/modules.php?op=modload&name=apa&file=index&apa_module_target=$page&".$vars."\"");
    }
  }

  if($target_blank)
    print(" target=\"_blank\">");
  else
    print(">");

  print("$txt_link</a>\n");
}

function apa_print_form($page)
{
  global $apa_ext,$apa_include_page;
  global $apa_options;
  global $apa_module_pn;
  global $apa_module_pn_url;
  global $apa_album_ID;
  global $apa_photo_ID;
  global $apa_page;

  if( !($apa_options[as_module] || $apa_module_pn))
    print("<form method=\"post\" action=\"$page.$apa_ext\">\n");
  else
  {
    if(!$apa_module_pn)
    {
      print("<form method=\"post\" action=\"$apa_include_page\">\n");
      apa_print_hidden_form_vars();
    }
    else
    {
      print("<form method=\"post\" action=\"$apa_module_pn_url/modules.php\">\n");
      apa_print_hidden("op","modload");
      apa_print_hidden("name","apa");
      apa_print_hidden("file","index");
      apa_print_hidden("apa_album_ID",$apa_album_ID);
      apa_print_hidden("apa_photo_ID",$apa_photo_ID);
      apa_print_hidden("apa_page",$apa_page);
      apa_print_hidden("apa_module_target",$page);
      //apa_print_hidden_form_vars();
    }
  }
}


function apa_timestamp2smalldate($time)
{
	global $l_at;
  
  $year = substr($time,0,4);
	$month = substr($time,4,2);
	$day = substr($time,6,2);
	$hour = substr($time,8,2);
	$minute = substr($time,10,2);
	$second = substr($time,12,2);

	$date = "$day-$month-$year $l_at $hour:$minute:$second";
	return $date;
}

function apa_printlogin($type)
{
  global $apa_options;
  global $apa_module_pn;
  if( !($apa_options[as_module] || $apa_module_pn))
  {
    global $apa_ext;
    global $l_register;
    global $apa_global_user_login,$apa_global_user_password,$apa_album_ID,$apa_photo_ID;

    print("<table class=\"login\" align=\"center\" cellspacing=\"0\" border=\"0\" cellpadding=\"2\">\n");
    print("<tr><td align=\"center\" valign=\"middle\">\n");
    apa_print_form($type);
    print("Login : <input class=\"login\" type=\"text\" name=\"apa_header_login\" value=\"$apa_global_user_login\" size=\"10\" maxlength=\"20\">\n");
    print("&nbsp;Password : <input class=\"login\" type=\"password\" name=\"apa_header_password\" value=\"$apa_global_user_password\" size=\"10\" maxlength=\"20\">\n");
    print("&nbsp;<input type=\"submit\" name=\"apa_header_login_submit\" value=\"Go!\">\n");
    print("&nbsp;");
    apa_print_link("register","","<font size=\"2\">".$l_register."</font>",1);
    apa_print_hidden("apa_album_ID",$apa_album_ID);
    apa_print_hidden("apa_photo_ID",$apa_photo_ID);
    print("</form>\n");
    print("</td></tr>\n");
    print("</table>\n");
  }
}

function apa_compute_rating($rate_str)
{
  $rates = explode(";",$rate_str);
  $nb_rates = count($rates);

  if($nb_rates == 0)
    return 0;
  if($nb_rates == 1)
    return $rates[0];

  $sum = 0;
  for($i = 0 ; $i < $nb_rates ; $i++)
    $sum += $rates[$i];

  return ($sum / $nb_rates);
}

function apa_add_rate($rate_str,$rate)
{
  return "$rate_str"."$rate".";";
}

function apa_add_vote($vote_str,$photo_ID)
{
  $votes = explode(";",$vote_str);
  $nb_votes = count($votes);

  if($nb_votes == 0)
    return "$photo_ID".";";

  if($nb_votes == 1)
  {
    if($votes[0] != $rate)
      return "$vote_str"."$photo_ID".";";
  }

  for($i = 0 ; $i < $nb_votes ; $i++)
  {
    if($votes[$i] == $photo_ID)
      return $vote_str;
  }

  return "$vote_str"."$photo_ID".";";
}

function apa_CreateThumb($filename,$album_path)
{
  global $apa_options;
  global $apa_module_basedir;
  
  $image = ImageCreateFromJPEG($apa_module_basedir."albums/".$album_path."/".$filename);
	$width = imagesx($image);
	$height = imagesy($image);
	$new_width = 100;
	$new_height = ($new_width * $height) / $width ;
	$thumb = imagecreate($new_width,$new_height);
	imagecopyresampled($thumb,$image,0,0,0,0,$new_width,$new_height,$width,$height);
	imagejpeg($thumb,$apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].$filename);
	imagedestroy($image);
} 

function apa_checkforadd($album_ID,$album_path)
{
  global $apa_tables;
  global $apa_options;
  global $apa_module_basedir;
  
  $handle = opendir($apa_module_basedir."albums/".$album_path);
	$file = readdir($handle);

	if (($file == "."))
		$file = readdir($handle);
	if (($file == ".."))
		$file = readdir($handle);

	while (($file != false))
	{
		if($file!="." || $file!=".." )
		{
			if(strcmp(substr($file,0,strlen($apa_options[thumb_prefix])),$apa_options[thumb_prefix]))
			{
        if(strcmp(substr($file,0,strlen($apa_options[small_prefix])),$apa_options[small_prefix]))
        {
          $url_encoded_file = rawurlencode($file);
          /*
             if(extension_loaded("gd") && $apa_options[with_gd])
             { 
             if(!file_exists($apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].$file))
             apa_CreateThumb($file,$album_path);
             }
           */
          $apa_query = "SELECT ID ".
                       "FROM $apa_tables[photos] ".
                       "WHERE filename='$url_encoded_file' ".
                       "AND album_ID='$album_ID'";
          $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
          if(!mysql_num_rows($result)) 
          {
            $apa_query = "INSERT INTO $apa_tables[photos] ".
                         "VALUES('$album_ID','$url_encoded_file','','','','','',0,0,NULL)";
            apa_mysql_query($apa_query,__FILE__,__LINE__);
            
            $apa_query = "UPDATE $apa_tables[albums] ".
                         "SET time=time,nb_photos=nb_photos+1 ".
                         "WHERE ID='$album_ID'";
            apa_mysql_query($apa_query,__FILE__,__LINE__);
          }
        }
			}
		} 
		$file = readdir($handle);
	}     
	closedir($handle);
}

function apa_checkforremove($album_ID)
{
  global $apa_tables;
	global $apa_options;
  global $apa_module_basedir;
  
  $apa_query = "SELECT path ".
               "FROM $apa_tables[albums] ".
               "WHERE ID='$album_ID'";
  $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
	$row = mysql_fetch_array($result);
	$album_path = $row[path];

  $apa_query = "SELECT * ".
               "FROM $apa_tables[photos] ".
               "WHERE album_ID='$album_ID'";
	$result = apa_mysql_query($apa_query,__FILE__,__LINE__);
	if(mysql_num_rows($result))
	{
		while($row = mysql_fetch_array($result))
		{
			$decoded_file_name = rawurldecode($row[filename]);
			if(!strcmp(substr($decoded_file_name,0,strlen($apa_options[thumb_prefix])),$apa_options[thumb_prefix]) 
        && !strcmp(substr($decoded_file_name,0,strlen($apa_options[small_prefix])),$apa_options[small_prefix]) )
			{
        $apa_query = "UPDATE $apa_tables[albums] ".
                     "SET time=time,nb_photos_nb_photos-1 ".
                     "WHERE ID='$album_ID'";
        apa_mysql_query($apa_query,__FILE__,__LINE__);

        $apa_query = "DELETE FROM $apa_tables[photos] ".
                     "WHERE ID='$row[ID]'";
				apa_mysql_query($apa_query,__FILE__,__LINE__);
				continue;
			}
			if(!file_exists($apa_module_basedir."albums/".$album_path."/".$decoded_file_name))
      {
        $apa_query = "SELECT nb_views,nb_comments ".
                     "FROM $apa_tables[albums] ".
                     "WHERE ID='$album_ID'";
        $result2 = apa_mysql_query($apa_query,__FILE__,__LINE__);
        $row2 = mysql_fetch_array($result2);
        $nb_views = $row2[nb_views]-$row[nb_views];
        $nb_comments = $row2[nb_comments]-$row[nb_comments];
        
        $apa_query = "UPDATE $apa_tables[albums] ".
                     "SET time=time,nb_photos=nb_photos-1,nb_views='$nb_views',nb_comments='$nb_comments' ".
                     "WHERE ID='$album_ID'";
        apa_mysql_query($apa_query,__FILE__,__LINE__);

        $apa_query = "DELETE FROM $apa_tables[photos] ".
                     "WHERE ID='$row[ID]'";
        apa_mysql_query($apa_query,__FILE__,__LINE__);

        $apa_query = "DELETE FROM $apa_tables[comments] ".
                     "WHERE tof_ID='$row[ID]'";
        apa_mysql_query($apa_query,__FILE__,__LINE__);

        if(file_exists($apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].$decoded_file_name))
          @unlink($apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].$decoded_file_name);
        if(file_exists($apa_module_basedir."albums/".$album_path."/".$apa_options[small_prefix].$decoded_file_name))
          @unlink($apa_module_basedir."albums/".$album_path."/".$apa_options[small_prefix].$decoded_file_name);
      }
		}
	}
}

function apa_parse_string($str)
{
  global $apa_module_basedir;
  
	$str = str_replace("<","&lt;",$str);
	$str = str_replace(">","&gt;",$str);
	$str = str_replace(":-)","<img src=\"".$apa_module_basedir."gfx/smile.gif\" alt=\":-)\">",$str);
	$str = str_replace(":)","<img src=\"".$apa_module_basedir."gfx/smile.gif\" alt=\":)\">",$str);
	$str = str_replace(";)","<img src=\"".$apa_module_basedir."gfx/oeil.gif\" alt=\";)\">",$str);
	$str = str_replace(";-)","<img src=\"".$apa_module_basedir."gfx/oeil.gif\" alt=\";-)\">",$str);
	$str = str_replace(":(","<img src=\"".$apa_module_basedir."gfx/ouin.gif\" alt=\":(\">",$str);
	$str = str_replace(":-(","<img src=\"".$apa_module_basedir."gfx/ouin.gif\" alt=\":-(\">",$str);
	$str = str_replace(":D","<img src=\"".$apa_module_basedir."gfx/dent.gif\" alt=\":D\">",$str);
	$str = str_replace(":-D","<img src=\"".$apa_module_basedir."gfx/dent.gif\" alt=\":-D\">",$str);
	$str = str_replace(":p","<img src=\"".$apa_module_basedir."gfx/tongue.gif\" alt=\":p\">",$str);
	$str = str_replace(":-p","<img src=\"".$apa_module_basedir."gfx/tongue.gif\" alt=\":-p\">",$str);
	$str = str_replace(":P","<img src=\"".$apa_module_basedir."gfx/tongue.gif\" alt=\":P\">",$str);
	$str = str_replace(":-P","<img src=\"".$apa_module_basedir."gfx/tongue.gif\" alt=\":-P\">",$str);
	$str = nl2br($str);
	return $str;
}

function apa_is_registered($login,$password)
{
  global $apa_tables;
  global $apa_module_pn;
  
  if($apa_module_pn)
  {
    return(pnUserLoggedIn());
  }
  else
  {
    $apa_query = "SELECT ID ".
                 "FROM $apa_tables[users] ".
                 "WHERE nickname='$login' ".
                 "AND password='$password'";
    $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
    if(mysql_num_rows($result))
      return true;
    else
      return false;
  }
}

function apa_check_user($login,$password,$user_ID)
{
  global $apa_tables;
  global $apa_module_pn;
	
  if($apa_module_pn)
  {
    $uid = pnSessionGetVar("uid");
  }
  else
  {
    $apa_query = "SELECT ID ".
                 "FROM $apa_tables[users] ".
                 "WHERE nickname='$login' ".
                 "AND password='$password'";
    $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
    if(mysql_num_rows($result))
    {
      $row = mysql_fetch_array($result);
      $uid = $row[ID];
    }
  }
  if($uid == $user_ID)
		  return 1;
  return 0;
}

function apa_is_admin($login,$password)
{
  global $apa_tables;
  global $apa_module_pn;

	if($apa_module_pn)
  {
    return (authorised(0, "::", "::", ACCESS_ADMIN));
  }
  else
  {
    $apa_query = "SELECT ID ".
                 "FROM $apa_tables[users] ".
                 "WHERE nickname='$login' ".
                 "AND password='$password' ".
                 "AND is_admin=1";
    $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
	  if(mysql_num_rows($result))
      return true;
    else
      return false;
  }
}

function apa_print_prev_next($pfile_ID,$pfile_name,$nfile_ID,$nfile_name,$album_ID,$album_path)
{ 
	global $apa_ext;
  global $apa_options;
  global $apa_tables;
  global $l_previous,$l_next,$l_start,$l_end;
  global $apa_module_basedir;
  
  print("<tr><td class=\"common\" align=\"center\">\n");
  
  print("<table align=\"center\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n");
  print("<tr><td align=\"left\">\n");
	
  if($pfile_ID != false)
  {
    if(!file_exists($apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].rawurldecode($pfile_name)))
      apa_print_link("photo","apa_album_ID=$album_ID&amp;apa_photo_ID=".$pfile_ID,"<< ".$l_previous,0);
    else
      apa_print_link("photo","apa_album_ID=$album_ID&amp;apa_photo_ID=".$pfile_ID," <img src=\"".$apa_module_basedir."albums/$album_path/$apa_options[thumb_prefix]".rawurldecode($pfile_name)."\" border=\"0\" align=\"middle\" alt=\"".rawurldecode($pfile_name)."\">",0);
  }
	else
		print("<strong>$l_start</strong>\n");
	
  print("</td>\n");
	print("<td align=\"right\">\n");
	
  if($nfile_ID != false)
  {
    if(!file_exists($apa_module_basedir."albums/".$album_path."/".$apa_options[thumb_prefix].rawurldecode($nfile_name)))
      apa_print_link("photo","apa_album_ID=$album_ID&amp;apa_photo_ID=$nfile_ID","$l_next >>",0);
    else
      apa_print_link("photo","apa_album_ID=$album_ID&amp;apa_photo_ID=$nfile_ID"," <img src=\"".$apa_module_basedir."albums/$album_path/$apa_options[thumb_prefix]".rawurldecode($nfile_name)."\" align=\"middle\" border=\"0\" alt=\"".rawurldecode($nfile_name)."\">",0);
  }
	else
		print("<strong>$l_end</strong>\n");
	
  print("</td></tr>\n");
  print("</table>\n");
  
  print("</tr></td>\n");
}

function apa_index_a_comment($photo_ID,$content)
{
  global $apa_tables;

  $content = preg_replace("/[^\w_ ]/","",$content);
  $exploded_content = explode(" ",$content);
  $i = count($exploded_content);
  $tmp_index_entry = "";
  $prev_content = "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ".
                  "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ".
                  "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ".
                  "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ".
                  "ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ".
                  "ZZZZ";
  for($j = 0;$j < $i;$j++)
  {
    $tmp_word = $exploded_content[$j];
    if(strlen($tmp_word) >= 3)
    {
      $apa_query = "SELECT ID ".
                   "FROM $apa_tables[searchindex] ".
                   "WHERE tof_ID='$photo_ID' ".
                   "AND content LIKE '%$tmp_word%'";
      $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
      if(!mysql_num_rows($result))
      {
        $apa_query = "SELECT content,ID ".
                     "FROM $apa_tables[searchindex] ".
                     "WHERE LENGTH(content)+".strlen($tmp_word)."+".strlen($tmp_index_entry)." <= 250 ".
                     "AND tof_ID='$photo_ID' ".
                     "AND content NOT LIKE '%$prev_content%'";
        $result2 = apa_mysql_query($apa_query,__FILE__,__LINE__);
        if(mysql_num_rows($result2))
        {
          $row2 = mysql_fetch_array($result2);
          $tmp_index_entry .= $row2[content].$tmp_word;
          $prev_content = $row2[content];
          
          $apa_query = "DELETE FROM $apa_tables[searchindex] ".
                       "WHERE ID='$row2[ID]'";
          apa_mysql_query($apa_query,__FILE__,__LINE__);
        }
        else
          $tmp_index_entry .= $tmp_word;

        if( ( (strlen($tmp_index_entry) + strlen($tmp_word)) >= 250 ) || ( $j == ( $i-1 ) ) )
        {
          $apa_query = "INSERT INTO $apa_tables[searchindex] ".
                       "VALUES('$photo_ID','$tmp_index_entry',NULL)";
          apa_mysql_query($apa_query,__FILE__,__LINE__);
          $tmp_index_entry = "";        
        }
      }
    }
  }
}

function apa_index_tof_comments($photo_ID)
{
  global $apa_tables;
  
  $apa_query = "SELECT content ".
               "FROM $apa_tables[comments] ".
               "WHERE ID='$photo_ID'";
  $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
  if(mysql_num_rows($result))
  {
    while($row = mysql_fetch_array($result))
    {
      apa_index_a_comment($photo_ID,$row[content]);
    }
  }
}

function apa_index_all_comments()
{
  global $apa_tables;
  
  $apa_query = "SELECT ID ".
               "FROM $apa_tables[photos]";
  $result = apa_mysql_query($apa_query,__FILE__,__LINE__);
  if(mysql_num_rows($result))
  {
    while($row = mysql_fetch_array($result))
    {
      apa_index_tof_comments($row[ID]);
    }
  }
}

function apa_print_search($type)
{
  global $apa_ext,$apa_album_ID,$apa_photo_ID;
  global $l_searchsearch,$l_searchin;
  global $l_searchincomments,$l_searchindescr;
  global $l_searchintitle,$l_searchinsubtitle;
  global $l_searchindatetaken;

  print("<tr><td align=\"center\" valign=\"center\">\n");
  apa_print_form("search");
  print("$l_searchsearch <input type=\"text\" name=\"apa_search_query\" size=\"20\" maxlength=\"100\">\n");
  print("$l_searchin <select name=\"apa_search_where\">\n");
  print("<option value=\"comments\">$l_searchincomments</option>\n");
  print("<option value=\"descr\">$l_searchindescr</option>\n");
  print("<option value=\"title\">$l_searchintitle</option>\n");
  print("<option value=\"subtitle\">$l_searchinsubtitle</option>\n");
  print("<option value=\"date_taken\">$l_searchindatetaken</option>\n");
  print("</select>\n");
  apa_print_hidden("apa_type",$type);
  apa_print_hidden("apa_album_ID",$apa_album_ID);
  apa_print_hidden("apa_photo_ID",$apa_photo_ID);
  print("<input type=\"submit\" value=\"$l_searchsearch\">\n");
  print("</form>\n");
  print("</td></tr>\n");
}

function apa_print_html_header($page_title)
{
  global $apa_theme_body_bgcolor,$apa_theme_body_textcolor;
  global $apa_theme_body_link,$apa_theme_body_vlink;
  global $apa_theme_body_alink,$apa_global_theme;
  global $apa_options;
  global $apa_module_basedir;
  global $apa_module_pn;
  
  if( !($apa_options[as_module] || $apa_module_pn))
  {
    print("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n");
    print("<html>\n");
    print("<head>\n");
    print("<title>$page_title</title>\n");
    print("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
    print("<style type=\"text/css\">\n");
    print("@import url(\"".$apa_module_basedir."themes/$apa_global_theme/theme.css\");\n");
    print("</style>\n");
    print("</head>\n");
    print("<body bgcolor=\"$apa_theme_body_bgcolor\">\n");
  }
  else
  {
    include($apa_module_basedir."themes/Default/theme.inc.php");
  }
}

function apa_print_noresult()
{
  global $l_noresultfound;
  
  print("<tr><td align=\"center\" valign=\"top\">\n");
  print("<strong>$l_noresultfound</strong>\n");
  print("</td></tr>\n");
}

?>
