<?php
/*
   Atomic Photo Album
   Copyright (C) 2001,2002 Constantin Charissis <charchi@ifrance.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 */

include("apa_phpinclude.inc.php");
apa_print_html_header($l_editprofile);

print("<table align=\"center\" border=\"0\">\n");
apa_print_form("edit_profile");

switch($apa_action)
{
  case "update_profile":
  {
    if( isset($apa_user_ID) && strlen($apa_nickname)>2 && 
        strlen($apa_password1)>2 && strlen($apa_password2)>2 && 
        strlen($apa_email)>2 && isset($apa_userlang) &&
        isset($apa_usertheme) )
    {
      if(apa_check_user($apa_global_user_login,$apa_global_user_password,$apa_user_ID))
      {
        if($apa_password1 == $apa_password2)
        {
          print("<tr><td align=\"center\">\n");
          $apa_query = "UPDATE $apa_tables[users] ".
                       "SET nickname='$apa_nickname',password='$apa_password1',email='$apa_email',".
                       "lang='$apa_userlang',theme='$apa_usertheme' ".
                       "WHERE ID='$apa_user_ID'";
          apa_mysql_query($apa_query,__FILE__,__LINE__);
          print("<strong>$l_profileedited</strong>\n");
        }
      }
    }
    break;
  }
  default:
  {
    if(isset($apa_user_ID))
    {
      if(apa_check_user($apa_global_user_login,$apa_global_user_password,$apa_user_ID))
      {
        $apa_query = "SELECT * ".
                     "FROM $apa_tables[users] ".
                     "WHERE ID='$apa_user_ID'";
        $apa_result = apa_mysql_query($apa_query,__FILE__,__LINE__);
        if(mysql_num_rows($apa_result))
        {
          $apa_row = mysql_fetch_array($apa_result);

          print("<tr><td align=\"center\" colspan=\"2\">\n");
          print("<strong><big>$l_editprofile</big></strong>\n");
          print("<br><br>\n");
          print("</td></tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_adminlogin </td>\n");
          print("<td align=\"left\"><input type=\"text\" name=\"apa_nickname\" value=\"$apa_row[nickname]\" size=\"20\" maxlength=\"20\"></td>\n");
          print("</tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_adminpass </td>\n");
          print("<td align=\"left\"><input type=\"password\" name=\"apa_password1\" value=\"$apa_row[password]\" size=\"20\" maxlength=\"20\"></td>\n");
          print("</tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_adminpass </td>\n");
          print("<td align=\"left\"><input type=\"password\" name=\"apa_password2\" value=\"$apa_row[password]\" size=\"20\" maxlength=\"20\"></td>\n");
          print("</tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_adminemail </td>\n");
          print("<td align=\"left\"><input type=\"text\" name=\"apa_email\" value=\"$apa_row[email]\" size=\"30\" maxlength=\"255\"></td>\n");
          print("</tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_userlang</td>\n");
          print("<td align=\"left\"><select name=\"apa_userlang\">\n");
          $handle = opendir("lang/");
          $file = readdir($handle);
          if($file == ".")
            $file = readdir($handle);
          if($file == "..")
            $file = readdir($handle);
          while($file != false)
          {
            if($file != "." || $file != ".." || $file != "lang")
            {
              $explode = explode(".",$file);
              if($explode[1] == $apa_row[lang])
                print("<option value=\"$explode[1]\" selected>$explode[1]</option>\n");
              else
                print("<option value=\"$explode[1]\">$explode[1]</option>\n");
            }// end if
            $file = readdir($handle);
          }// end while
          closedir($handle);
          print("</select>\n");
          print("</td></tr>\n");

          print("<tr>\n");
          print("<td align=\"right\">$l_usertheme</td>\n");
          print("<td align=\"left\"><select name=\"apa_usertheme\">\n");
          $handle = opendir("themes/");
          $file = readdir($handle);
          if($file == ".")
            $file = readdir($handle);
          if($file == "..")
            $file = readdir($handle);
          while($file != false)
          {
            if($file != "." || $file != ".." || $file != "themes")
            {
              if($file == $apa_row[theme])
                print("<option value=\"$file\" selected>$file</option>\n");
              else
                print("<option value=\"$file\">$file</option>\n");
            }// end if
            $file = readdir($handle);
          }// end while
          closedir($handle);
          print("</select>\n");
          print("</td></tr>\n");

          print("<tr><td align=\"center\" colspan=\"2\">\n");
          print("<input type=\"submit\" value=\"$l_editsubmit\">\n");
          print("</td></tr>\n");
          apa_print_hidden("apa_user_ID",$apa_user_ID);
          apa_print_hidden("apa_action","update_profile");
        }
      }
    }
    break;
  }
}

print("</td></tr>\n");
print("</form>\n");
print("</table>\n");

include("apa_footer.inc.php");

?>
